#include "IZ_video.h"

IZ_ProcedureResult IZ_SaveVideoConfig(const char* config_path, IZ_VideoConfig* config) {
	if (!ini_putl("Video", "Width", config->width, config_path)) {
		return 1;
	}
	if (!ini_putl("Video", "Height", config->height, config_path)) {
		return 1;
	}
	if (!ini_putl("Video", "MaxFps", config->max_fps, config_path)) {
		return 1;
	}

	return 0;
}

void IZ_LoadVideoConfig(const char* config_path, IZ_VideoConfig* config) {
	config->width = ini_getl("Video", "Width", 640l, config_path);
	config->height = ini_getl("Video", "Height", 480l, config_path);
	config->max_fps = ini_getl("Video", "MaxFps", 30, config_path);
}

IZ_ProcedureResult IZ_InitializeVideo(IZ_VideoConfig* config, SDL_Window** window, SDL_Surface** screen_surface) {
	*window = SDL_CreateWindow(
		APP_NAME,
		SDL_WINDOWPOS_CENTERED,
		SDL_WINDOWPOS_CENTERED,
		config->width,
		config->height,
		SDL_WINDOW_SHOWN
	);
	if (*window == NULL) {
		fprintf_s(stderr, "Window could not be created! SDL_Error: %s\n", SDL_GetError());
		return 1;
	}
	*screen_surface = SDL_GetWindowSurface(*window);
	return 0;
}
